/*WP Ajax Edit Comments Editor Interface Script
--Created by Ronald Huereca
--Created on: 05/04/2008
--Last modified on: 10/01/2008
--Relies on jQuery, wp-ajax-edit-comments, wp-ajax-response, thickbox
	
	Copyright 2007,2008  Ronald Huereca  (email : ron alfy [a t ] g m ail DOT com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
(function($) {
$.ajaxcommenteditor = {
	init: function() { initialize_events(); load_comment(); },
	vars: {}
};
	var vars = $.ajaxcommenteditor.vars;
	//Initializes the edit links
	function initialize_events() {
  	//Read in cookie values and adjust the toggle box
  	var cookieValue = readCookie('ajax-edit-comments-options');
    if (cookieValue) {
    	$("#comment-options").attr("class", cookieValue);
    }
    
    //The "more options" button
  	$("#comment-options h3").bind("click", function() { 
    	$("#comment-options").toggleClass("closed"); 
      createCookie('ajax-edit-comments-options', $("#comment-options").attr("class"), 365);
      return false; 
    });
    //Cancel button
    $("#cancel,#status a, #close a").bind("click", function() { self.parent.tb_remove();
    return false; });
    //Title for new window
    $("#title a").bind("click", function() { window.open(this.href); return false; } );
    //Save button event
  }
	function load_comment() {
  	//Pre-process data
  	var cid = parseInt($("#commentID").attr("value"));
    var pid = parseInt($("#postID").attr("value"));
    var action = $("#action").attr("value");
  	var s = {};
    s.element = $("#comment-edit-header").attr("id");
    s.response = 'ajax-response';
    s.cid = cid;
    s.pid = pid;
    s.action = action;
    s.type = "POST";
    s.url = vars.AEC_PluginUrl + "/php/AjaxEditComments.php";
    s.data = $.extend({ action: s.action, cid: s.cid,pid:s.pid },'');
    s.global = false;
    s.timeout = 30000;
  	//Change the edit text and events
    $("#status").show();
    $("#status").attr("class", "success");
  	$("#message").html(vars.AEC_Loading);
  	//todo - Possibly do something on failure here
    s.success = function(r) {
    	var res = wpAjax.parseAjaxResponse(r, s.response,s.element);
      //Add event for save button
      var error = false;
      $("#save").bind("click", function() { save_comment(s); return false; });
      $.each( res.responses, function() {
        	if (this.what == "error") { //error
          	error = true;
          	$("#status").attr("class", "error");
            $("#message").html(this.data);
            $("#close-option").show();
            //remove event for save button
            $("#save").unbind("click");
          } else { //success
            //Load content
            switch(this.what) {
              case "comment_content":
               	$("#comment").html(this.data); //For everyone else
                $("#comment").attr("value",this.data); //For Opera
                break;
              case "comment_author":
                $("#name").attr("value", this.data);
                break;
              case "comment_author_email":
                $("#e-mail").attr("value", this.data);
                break;
              case "comment_author_url":
                $("#URL").attr("value", this.data);
                break;
              case "gravatar":
                $("#gravatar").html(this.data).show();
                break;
          	}
          }
      });
      if (!error) {
      	//Enable the buttons
        $("#save, #cancel").removeAttr("disabled");
      	//Update status message
        $("#status").attr("class", "success");
        $("#message").html(vars.AEC_LoadSuccessful);
      }
     
    }
    $.ajax(s);
  } //end load_comment
  function save_comment(data) {
  	//Update status message
    $("#status").attr("class", "success");
    $("#message").html(vars.AEC_Saving);
    $("#save").attr("disabled", "disabled");
  	data.action = "savecomment";
    var error = false;
    //Read in dom values
    var name = encodeURIComponent($("#name").attr("value"));
    var email = encodeURIComponent($("#e-mail").attr("value"));
    var url = encodeURIComponent($("#URL").attr("value"));
    var comment = encodeURIComponent($("#comment").attr("value")); 
    var nonce = $("#_wpnonce").attr("value");
    data.data = $.extend({ comment_content: comment, comment_author: name, comment_author_email: email, comment_author_url: url,action: data.action, cid: data.cid,pid:data.pid, _wpnonce: nonce },'');
    //data.data = $.extend(data.data, {mycode: "value", mycode2: "value"}); //Extend example
    //todo - possibly do something with failure also
    data.success = function(r) {
    	var res = wpAjax.parseAjaxResponse(r, data.response,data.element);
			try {
				$.each( res.responses, function() {
						if (this.what == "error") { //error
							error = true;
							$("#save").removeAttr("disabled");
							$("#status").attr("class", "error");
							$("#message").html(this.data);
							$("#close-option").show();
						} else { //success 
							switch(this.what) {
								case "comment_content":
									comment = this.data;
									break;
								case "comment_author":
									name = this.data;
									break;
								case "comment_author_url":
									url = this.data;
									break;
							}
						}
				});
			} catch(err) {}
      if (!error) {
      	try {
        	self.parent.jQuery.ajaxeditcomments.update_comment("edit-comment" + data.cid,comment);
          self.parent.jQuery.ajaxeditcomments.update_author("edit-author" + data.cid,name, url);
        } catch (err) {}
      	$("#status").attr("class", "success");
        $("#message").html(vars.AEC_Saved);
        self.parent.tb_remove(); 
        //$("#close-option").show();
      }
    };
    $.ajax(data);
  }
  //Cookie code conveniently stolen from http://www.quirksmode.org/js/cookies.html
	function createCookie(name,value,days) {
    if (days) {
      var date = new Date();
      date.setTime(date.getTime()+(days*24*60*60*1000));
      var expires = "; expires="+date.toGMTString();
    }
    else var expires = "";
    document.cookie = name+"="+value+expires+"; path=/";
	}
  function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
      var c = ca[i];
      while (c.charAt(0)==' ') c = c.substring(1,c.length);
      if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
  }
})(jQuery);